SystemOrganization addCategory: #KEGGeneratorFiniteStateMachinesTest!

!KEGGeneratorTest methodsFor: '*KEGGeneratorFiniteStateMachinesTest' stamp: 'KjellGodo 5/18/2013 11:34'!
"(| defineMethod-:(" testsectionsStartingWithC "sectionsStartingWith: sectionPrefixBoundary "")
	notes-:(		Method Version: keg2.
				 Copyright Kjell E God 20020423
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030406 20020423
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 2 >>
	)-notes methodBody-:(
 (| let-:(""| testBlk prefix |"")
    letBody-:(""					""( MT b:#sectionsStartingWith: s:self ).""

	^(	(	( sectionPrefixBoundary isKindOf:( BlockClosure ) )		or:[
			( sectionPrefixBoundary respondsTo:( #value: ) )			]
		) ifTrue:[ 
			( testBlk := sectionPrefixBoundary ).
			( self sortInto:( KEGRuleBaseParam new
				""1""when:[ :x | ( testBlk value: x ) ifTrue:[ 2 ]ifFalse:[ 1 ] ]   perform:( nil ); ""<---( Remember that nil = [ :b :x | x ] the empty 2 parameter BlockClosure.  And sortInto: ... perform:[ :b :x | x ] means stick x into the bag for self( this state( state ''1'' ) ) and when you are leaving self( this state( state 1 ) ) then return the bag for self( this state( state 1 ) ).  The two states are labelled ''1'' and ''2''. )""
				""2""when:[ :x | ( testBlk value: x ) ifTrue:[ 1 ]ifFalse:[ 2 ] ]   perform:( nil )
				)
			) ]
		ifFalse:[ 
		    ( prefix := sectionPrefixBoundary ).
		    ( self sortInto:( KEGRuleBaseParam new
		        ""1""when:[ :x | ( x = prefix ) ifTrue:[ 2 ]ifFalse:[ 1 ] ]   perform:( nil ); ""<---( nil is used instead of [ :x | x ] because in the SortedCollection class>>value:value: it is insinuated that any non BlockClosure implementation of the >>value: message will be faster than the one for BlockClosures. )""
		        ""2""when:[ :x | ( x = prefix ) ifTrue:[ 1 ]ifFalse:[ 2 ] ]   perform:( nil )
		        )
		    ) ]
	)""return:( 					MT e:#sectionsStartingWith: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return a sequence of sequences( IE: return a sequence of OrderedCollections( 
		ie: sortInto: bags ) )
	( IE: return a Generator of OrderedCollections ).
	The simplest case is where self = < s1 s2 s3 ... P a1 a2 a3 ... P b1 b2 b3 ... >
	And then the sequence returned by self-:( this method ) is-:
	< OC( s1 s2 s3 ... sN ) OC( P a1 a2 a3 ... aM ) OC( P b1 b2 b3 ... ) ... >
	where M is a Natural and N is an Integer where 0 <= N .
	( The Natural numbers are < 1 2 3 4 ... > )

 )-summary
 methodDescriptionDetail-:(

	( In the sortInto: lingo the subSequences returned by the Generator returned
		by the KEGGenerator>>sortInto: method are called bags.  But they are
		not instances of the Bag Class.  They are an OrderedCollection. )( lingo
		means specialized language-:( for those of you who don't speak US American.
		American, as opposed to English. ) )
	Please note that the OrderedCollections OC returned is always the same OC so
	if you want to do-:(
		(
		( 
		( 'a car a bus a truck' asCharacter
		)  sectionsStartingWith: $a 
		) asOrderedCollection 
		)

	)-do
	you won't get what you expect.  In order to get what you expect you will have
	to instead do-:(
		(
		(
		(
		( 'a car a bus a truck' asCharacter
		) sectionsStartingWith:( $a )
		) collect:[ :oc | oc copy ] 
		) asOrderedCollection 
		)

	)-do.
	Also please see the methods-:(
		. . . . . . . . . . . .
		KEGGenerator>>sortIntoChangeOCsToGenerators
		KEGGenerator>>sortIntoChangeOCsToStringGenerators
		. . . . . . . . . . . .
	)and the KEGGeneratorFiniteStateMachines package .

	Suppose self = 
	   <	s1 s2 s3 ... sK
		P1   s11 s12 s13... s1N 
		P2   s21 s22 s23 ... s2M  
		P3   s31 s32 s33 ... s3G
		P4 ... >
	THEN-: the answer returned from self( this method ) = r = < r0  r1  r2  r3 ... >
	and P = sectionPrefixBoundary
	Then
		r0 = OC( s1 s2 s3 ... sK )
		r1 = OC( P1   s11 s12 s13... s1N )
		r2 = OC( P2   s21 s22 s23 ... s2M )
		r3 = OC( P3   s31 s32 s33... s3G )
			etc . . .
	where s1N = s( 1, N ), s23 = s( 2, 3 ), etc . . . where( 0 <= K )and( 0 <= N )
		and( 0 <= M ) and( 0 <= G ) etc. are Integers, and
		the-:(   s11 s12 s13... s1N   ) notations mean 0 or more elements in a sequence,
		So OC( s1 s2 s3 ... sK ) might very well be empty and so equal to OC(  )
		the empty OrderedCollection, as can be seen in the testCase below,
	where EITHER-:(
		P1 = sectionPrefixBoundary
		P2 = sectionPrefixBoundary
		P3 = sectionPrefixBoundary
		     . . .
		orCase2-:
		( sectionPrefixBoundary value:( Pi ) ) = true		for i = 1 2 3 ...
			and-:
			( sectionPrefixBoundary value:( x ) ) = false
			for all x that are not elements of the Set-:{  P1 , P2 , P3 ...  }
	).
	Case2 is because sectionPrefixBoundary can be a single parameter
	BlockClosure or monadicValuable( ie: it responds to the >>value: message. ).

	In other words return all the subSequences of self that start with
	sectionPrefixBoundary .

	In other words return the ( P * ) subSequences which match with self like
	in some psuedo regular expression matching pattern-:
		* ( sectionPrefixBoundary * )*

	A frequently used function relating to Strings is-:(

		( 'somePrefixString' )containedIn:( x )

	). Like if you were to do-:(
		(
		( someText linesStrGen 
		) sectionsStartingWith:[ :ln | ( 'somePrefixString' )containedIn:( ln ) ]
		)

	) where someText is a text String of multiple seperate lines ie: it includes-:(

		( String lineDelimiter ) 

	) Character subSequences .

	In order to get linesStrGen you need to install the
	KEGStringGeneratorFileStream-6-0.pac Package( Dolphin Smalltalk ).

 )-detail
 usage-:(

	Here is some as yet untested code which might be used to section up RichText
	into colored and Fonted subSections-:(

		(											Array p1:
			( aRichText rtf )								p2:
			[ :str | 
				( nextWord indexOfSubCollection:( '\plain\' ) ) = 0
			]
		) mifNotNil:[ :theRTFStr :plainFirstBlk |
			(
			(
			(
			(
			( 
			( theRTFStr asCharacter <---------------------------( singular is plural style )
			) replaceAll:#( '\plain\' )with:#( ' \plain\' ) 
			) asString asStringGenerator subStringsWithBlanks
			) pairUpAllNeighbors:[ :word :nextWord | 
				( plainFirstBlk value:( nextWord ) 
				) ifTrue:[ word copyFrom:( 1 )to:( word size - 1 ) ]
			  ]
			) sectionsStartingWith:( plainFirstBlk )
			) collect:[ :oc | oc asArray ] <----------------( must copy the reused oc bag )
			) asOrderedCollection
		]

	)-subSections.    Note the linear indentation style.  And imagine what a mess this
	thing would be if the linear indentation style was not used.  Also note the
	Lambda Calculus functional style of making local variables by using function
	input parameters as exampled by the use of Object>>ifNotNil: where the input
	parameters :theRTFStr and :plainFirstBlk are used as a temporary local variables.
	I sometimes use this style just for fun.  Sometimes it can be useful to clean things
	up.  But mostly I would be forced to use regular local variables because they are
	faster.  Some might want
	to collapse the initial 5 empty leftParens into something like ((((( , but I find the
	white space to be more relaxing.  Like they do in coffee table books.  Damn if 
	the whole thing isn't white space.  One 351 page book of blank white pages.
	But hay, feel that paper!!  That's real monochromed 300lb weight,    that.
	The sequence of OrderedCollection ''bags'' returned by >>sectionsStartingWith: is
	actually all the same bag but with possibly different contents for each slot place it is
	at in the sequence returned so when you want to make asOrderedCollection then
	you have to make copys of the bag in order to get it to exist in memory as multiple
	bags all symultaineously existing.  the one bag is reused as a memory and speed saving
	device, as is commonly done in the implementation of Generator creation methods.
	Generators have a Stream like ability to save on memory, except even more so.  But
	with RAM so cheap nowadays, one almost has to ask: why bother.
	String>>asCharacter returns a Generator on a Stream of Characters in the original
	String, as per the singular is plural Generator style.
	Array>>mifNotNil: is like-:( Object>>ifNotNil: UndefinedObject>>ifNotNil: )
	but is used with BlockClosures with multiple input parameters like the-:(
		[ :theRTFStr and :plainFirstBlk | ... ]
	)Block used above.  Via the BlockClosure>>valueWithArguments: function.

 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:( "

	( self assert:( 
		( ( ( #(  ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) )
		) description:( '( ( ( #(  ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) )' ) ).

	( self assert:( 
		( ( ( #( 1 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) ( 1 ) )
		) description:( '( ( ( #( 1 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) ( 1 ) )' ) ).

	( self assert:( 
		( ( ( #( 2 3 4 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 4 ) )
		) description:( '( ( ( #( 2 3 4 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 4 ) )' ) ).

	( self assert:( 
		( ( ( ( #( 1 ) asGenerator sectionsStartingWith:( 1 ) ) removeFirst ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 ) )
		) description:( '( ( ( ( #( 1 ) asGenerator sectionsStartingWith:( 1 ) ) removeFirst ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 ) )' ) ).

	( self assert:( 
		( ( ( #( 2 3 1 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 ) )
		) description:( '( ( ( #( 2 3 1 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 ) )' ) ).

	( self assert:( 
		( ( ( #( 2 3 1 4 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 ) )
		) description:( '( ( ( #( 2 3 1 4 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 ) )' ) ).

	( self assert:( 
		( ( ( #( 2 3 1 4 5 1 1 1 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 ) )
		) description:( '( ( ( #( 2 3 1 4 5 1 1 1 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 ) )' ) ).

	( self assert:( 
		( ( ( #( 2 3 1 4 5 1 1 1 6 7 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 6 7 ) )
		) description:( '( ( ( #( 2 3 1 4 5 1 1 1 6 7 ) asGenerator sectionsStartingWith:( 1 ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 6 7 ) )' ) ).

	( self assert:( 
		( ( ( #(  ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) )
		) description:( '( ( ( #(  ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) )' ) ).

	( self assert:( 
		( ( ( #( 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) ( 1 ) )
		) description:( '( ( ( #( 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  ) ( 1 ) )' ) ).

	( self assert:( 
		( ( ( ( #( 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) removeFirst ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 ) )
		) description:( '( ( ( ( #( 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) removeFirst ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 1 ) )' ) ).

	( self assert:( 
		( ( ( #( 2 3 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 ) )
		) description:( '( ( ( #( 2 3 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 ) )' ) ).

	( self assert:( 
		( ( ( #( 2 3 1 4 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 ) )
		) description:( '( ( ( #( 2 3 1 4 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 ) )' ) ).

	( self assert:( 
		( ( ( #( 2 3 1 4 5 1 1 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 ) )
		) description:( '( ( ( #( 2 3 1 4 5 1 1 1 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 ) )' ) ).

	( self assert:( 
		( ( ( #( 2 3 1 4 5 1 1 1 6 7 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 6 7 ) )
		) description:( '( ( ( #( 2 3 1 4 5 1 1 1 6 7 ) asGenerator sectionsStartingWith:[ :x | x = 1 ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( ( 2 3 ) ( 1 4 5 ) ( 1 ) ( 1 ) ( 1 6 7 ) )' ) ).


	( self assert:( 
		( ( ( ( 'a car a bus a truck' asSequence ) sectionsStartingWith:( $a ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  )( $a $  $c )( $a $r $ )( $a $  $b $u $s $ )( $a $  $t $r $u $c $k ) )
		) description:( '( ( ( ( ''a car a bus a truck'' asSequence ) sectionsStartingWith:( $a ) ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  )( $a $  $c )( $a $r $ )( $a $  $b $u $s $ )( $a $  $t $r $u $c $k ) )' ) ).

	( self assert:( 
		( ( ( ( 'a car a bus a truck' asSequence ) sectionsStartingWith:[ :c | c = $a ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  )( $a $  $c )( $a $r $ )( $a $  $b $u $s $ )( $a $  $t $r $u $c $k ) )
		) description:( '( ( ( ( ''a car a bus a truck'' asSequence ) sectionsStartingWith:[ :c | c = $a ] ) collect:[ :oc | oc asArray ] ) asArray ) = #( (  )( $a $  $c )( $a $r $ )( $a $  $b $u $s $ )( $a $  $t $r $u $c $k ) )' ) ).

	"	(
		(
		(
		( 'a car a bus a truck' asCharacter 
		) sectionsStartingWith:( $a )
		) collect:[ :oc | oc asArray ] 
		) asArray
		) =
		#(	(  )
			( $a $  $c ) 
			( $a $r $ )
			( $a $  $b $u $s $ ) 
			( $a $  $t $r $u $c $k )
		)


 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	Here is a lot of unrelated malarcky that is being left here in case anybody does
	a search like-:( ( on any ClassHierarchyBrowser )=> <Alt>=> <M>(Method)=> 
		<B>(Browse...)=> <O>( Method Text... )=> ( enter-: 'KEGParam' without
		the quotes )=> <Enter> )-asearchlike
	Please note that P is the Abreviation for KEGParam and in order to get access
	to this abreviation you must include the Abreviations( [_]: should be
	changed to KEGAbreviations ) in the poolDictionaries: of the Class you are
	creating a method for.  See the KEGGenerator Class definition for an example.

	Now you should also note that anObject can be a KEGParam so it can
	participate in the KEGParameter patterns protocals.  As of today
	<D:20020423> if anObject isParam then anObject is expected to have the
	following form-: aKEGParam( aMonadicValuable )
	where aMonadicValuable is anything that responds to the >>value: message.

 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: '*KEGGeneratorFiniteStateMachinesTest' stamp: 'KjellGodo 5/18/2013 11:50'!
"(| defineMethod-:(" testsortIntoC "sortInto: aKEGRuleBaseParam "")
	notes-:(		Method Version: keg9.
				 Copyright Kjell E God Sep  6 1998
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030410, 20030321, 20030212,
	20010731, 20010121, Mar 22 1999, Sep  6 1998
	<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 9 >>
	)-notes methodBody-:(
 (| let-:(""| resetMainSequence anIndexedCollection bags selectors selector states
	oldStateIndex presentStateIndex nextStateIndex returnedBag return returnBag
	returnBlk presentBag aFooArray seqTerminationMarker stopNow |"") <---( KEG8-: added stopNow )
    letBody-:(""					""( MT b:#sortInto: s:self ).""

	( anIndexedCollection := aKEGRuleBaseParam isParam
		ifTrue:[ aKEGRuleBaseParam ]ifFalse:[ aKEGRuleBaseParam asOrderedCollection ] 
	).
	( bags := anIndexedCollection collect:[ :n | OrderedCollection new ] ).
	( selectors := anIndexedCollection collect:[ :x | x key""TestBlocks"" ] ).
	( states := anIndexedCollection collect:[ :x | x value""StateBlocks"" ] ).
	( anIndexedCollection do:[ :x | x isParam ifTrue:[ x removeAll ] ] ).
	( anIndexedCollection isParam ifTrue:[ anIndexedCollection removeAll ] ).

	( resetMainSequence := self abstractGenerator new
		resetBlock:[ presentStateIndex := 1""FirstState"" .  returnedBag := false .
			selector := selectors at:1""FirstSelector"" .  bags do:[ :x | x removeAll ] .
			self reset ]
		nextBlock:[ self next ] 
	).
	( seqTerminationMarker :=( aFooArray:=KEGFooArray new )asSingletonGenerator ).

	returnBlk := [
		( returnBag := bags at:( presentStateIndex ) ).
		(
		( return := 
		( states at:( presentStateIndex )
		) value:( returnBag )value:( #result""Bag"" )
		) = #result""Bag""
		) ifTrue:[ returnBag ]
		 ifFalse:[ ( return == KEGFooArray )ifTrue:[ aFooArray ]ifFalse:[ return ] ] ""<----------( KEG5: Continue to support the old way where if returnBlk returned KEGFooArray then no bag would be returned for the present state and we continue onto the next state. )""
	] .
	^(
		( resetMainSequence , seqTerminationMarker )collect:[ :x | ""D d:?. <-----( break point to debug KEGMiscScripts>>trade: . KEG6. )""
			( returnedBag ifTrue:[ 
				( ( bags at:( oldStateIndex ) ) removeAll ).
				( returnedBag := false ).( presentStateIndex := nextStateIndex ) ] 
			)."".........................""
			( 
			( x == aFooArray ""<-------------------------------------------------------------------------------( self has run out and returned nil. So clean up and return the last bag. )( KEG5 )""
			) ifFalse:[ 
				( selector value:( x )
				) ifNil:[ stopNow := true ]ifNotNil:[ :nextSI | ""<----------------------( KEG7. KEG8-: changed 'stop' to 'stopNow' . )""
					(
					( nextSI isParam ""<---( KEG9: We use isParam instead of isKindOf: Array because isParam is more of a Type thing than isKindOf: and can define a Type of Objects across multiple different Classes subHierarchies of Object .  But I think that in Dolphin isKindOf: is actually twice as fast.  Or something.  Oh well.  We go for flexibility instead. )""
					) ifTrue:[ ( nextStateIndex := ( nextSI  p1 ) ). presentStateIndex ] ""<------( KEG9: This presentStateIndex is a little iffy.  But it seems to work.  The other stuff seems more localized and easier to verify and understand and track.  But the test cases made so far work so I guess it works. )""
					  ifFalse:[ ( nextStateIndex := nextSI )return:( presentBag := bags at:( nextStateIndex ) ) ] ""<-------( KEG9: Oldat:Code-: nextStateIndex := nextSI )""
					) ifNotNil:[ :stuffItIntoState | ""<---------( KEG9 )""
						(
						( bags at:( stuffItIntoState )						
						) add:(
							( states at:( stuffItIntoState ) ""<------( KEG9: Was-: nextStateIndex )""
							) value:( presentBag )value:( x )
							)
						).
						( presentBag := bags at:( nextStateIndex ) ) ""<----------( KEG9:  Have to redo this in case the ( nextSI p1 ) case was done. )""
					  ]
				]""-ifNotNil:"" ]""-ifFalse:""
			).""......................"" ""<----------------------------------------------------( KEG4: Changed #sortInto:''Bag'' into presentBag. )""
			(
			( stopNow == true ""<-----------------------------------( KEG8: change 'stop' to 'stopNow == true' since stop might be set to true by other things than the ifNil:ifNotNil: above so we don't want to get screwed up by those or screw those up.  In fact stop is for self and not for the returned KEGGenerator!!  So when self runs out of elements then stop goes to true.  Prior to the ifNil:ifNotNil: above.  Which is not the kind of signaling we had in mind when we did change KEG7.  We had in mind a stop flag that would be totally local to the KEGGenerator returned by self-:( this method ).  We use == true because it combines the isNil functionality.  So if stopNow is nil you get the same reaction as when stopNow is false.  So you don't have to make sure to initialize stopNow to false.  You can just leave it as nil and that initializes it.  So here we think like nil == false .  So nil becomes a Boolean and is equal to false in functionality.  And finally, this change will eliminate the bug where self runs out of elements and then the present bag, for the present state, presently being filled by the elements of self( or whatever other elements ) never gets returned below.  And we want the present bag to be returned. )""
			) ifFalse:[ ""<----------------------------------------------( KEG7: stop is never nil so we don't have to use the stop == true way. )""
				(
				( x == aFooArray 
				) ifTrue:[ returnBlk value ]ifFalse:[ ""<---------------------------------------( self has run out and returned nil. So clean up and return the last bag. )( KEG5 )""
					( nextStateIndex = presentStateIndex ) ""<---------------------------------------------------( and:[ x ~= FooArray ] )""
						ifTrue:[ aFooArray ] ""<------------------------------------------------------------------( keep the elements of self coming, don't return anything yet. )( KEG5 )""
						ifFalse:[ 
							( selector := ( selectors at:( nextStateIndex ) ) ).
							( returnedBag := true ).
							( oldStateIndex := presentStateIndex ).
							( returnBlk value ) ] ]
				)
			]""-stop==trueifFalse:""
			)
		]ignoring:( aFooArray )""<-----------------------------------------------------------------------------( KEG5 )""

	)""return:( 					MT e:#sortInto: s:self )""

    "")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(
	There is no methodDescriptionSummary possible for self-:( this method ) but here
	and let me try-:
	self-:( this method ) makes and returns a new Generator G which is a
	Finite State Machine( FSM ) like what you have seen in any compiler class
	in any computer science section at any college that has one, Or having been
	excluded from every college by the expensive quota system from hell, where it's
	WE DON'T HAVE ENOUGH MONEY-:( don't spare the horses man, step on it ),
	( dump that budget down a rat hole, if you please, i/they/we want to hit the speed
	of sound before the crack ) ie: having been so excluded : if ever you just went
	ahead and picked up a book on Compilers from Amazon.com or whereEver
	THEN: you would have seen the FSMs in there in the front of that compiler
	( or finite automata ) book.  phew!!
	How it does that is a matter of details, Lots and Lots
	of details.  Of which as of <D:20030212> most of them are now lost in the
	<<See Zoomer FILE: c:\teleagnt\text\paperfil.zmr AT:  >> dump in Smalltalk/V 2.0
	I think.  ( probably could do with a redoing anyway. )  But for now you can look
	at all the uses of >>sortInto: by Browsing the Senders of >>sortInto: or in
	Dolphin Smalltalk the References to >>sortInto: .
 )-summary
 methodDescriptionDetail-:(

	sortInto: works like this-:		( now take a deep breath. hold it hold it holdit,
	you feel that? well get used to it... )
	You take a base Generator called aGen.  You want to make a Finite State Machine
	out of it ( a FSM ).  So you expectorate thus-:

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	Now if aGen was a Generator sequence of Characters as can be made by
	( aString asSequence ) then this new Generator r would return OrderedCollection
	''bags'' that had the period seperated sentences in them.  But the first element of the
	first bag would probably not be a $. Character but the first element of each bag
	after that would have $. as the first element.  So if you wanted the periods to
	go at the ends then you could do-:(

		( r sectionPrefixes:1fromSuffixes:1 )

	) to get a new Generator sequence that has the periods at the end of each sentence.
	You could also in this case do-:(
		aGen sectionsEndingWith:( $. )
	) but okay.  It's just an example.  So how does-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	)work?  Well, each when:here:whenLeaving: creates a numbered state in the
	r Generator.  The first state to run is state 1.  Marked ''1'' above.  So first the
	when: Block executes and returns nextState.  Now if nextState = 1 then the
	here: Block of state 1 is evaluated as nil = [ :bag :x | x ] so the x is just returned
	unchanged and is stuck into the bag( OrderedCollection ) for state 1.  Now as long
	as x is not = $. then all these x's just keep getting stuffed into the bag for state 1.
	But as soon as x = $. then state 1's here: block returns 2 which means we are
	switching to state 2.  So immediately this latest period x is dumped into the
	here: block of state 2 which dumps it into the bag for state 2.  Next the
	whenLeaving: block ( nil = [ :bag | bag ] ) is evaluated with the bag for state 1
	as its input parameter :bag and in this case the bag for state 1 is just returned by
	( r next ) .   So how is it that r does all of these things? in what context?  Well it is in
	some context where the >>next message gets sent to r over and over like in the
		( r last )
	expression or ( r asArray ) or ( r do:[ :x | ... ] ) or ( r inject:( ... )into:[ :v :x | ... ] )
	or ( r asString ) etc.
	And thus it continues until aGen has no more elements in it.  Now it should be
	noted that all the OrderedCollection bags returned by a single state are the same
	bag returned over and over with different contents each time.  So if you want to
	do an ( r asOrderedCollection ) you will have to do it like-:(
		( r collect:[ :oc | oc copy ]
		) asOrderedCollection
	) in order to get all the OrderedCollections to stay in MEMORY at the same time.
	Otherwise you will get some crazy funk you won't soon figure out unless you know
	this here ''should be noted'' is the case.  Also you can please note that in-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	) the two states are almost mirror images of each other.  This is often the case
	and such mirror images can be thought of as a single super state where mostly
	it just loops back into itself doing nothing.  But sometimes it wants to output
	what it has so far and start on a new bag.  In such cases you use switched mirrored
	states like above.   Now we can also have states that are exact mirrors of each
	othere like-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	)now this would return bags that were single sentences but without any
	trailing period.  And the trailing period would be stuck into its own bag and
	returned all by itself.  During a 
		( stringGen := KEGGenerator streamGenerator asStringGenerator ).
		( ( r collect:[ :oc | ( stringGen on:( oc ) ) asString ] ) asArray )
	operation for example( which only allocates the stringGen once and then
	reuses it over and over to create each String. ).
	( Now these examples are somewhat pathological since why not just use
		Stream>>upToIncluding:( $. )
	to do the same thing?  Yes you probably would.  But okay quit raining on my
	parade here, I just wanted something simple.  Okay? )
	So it turns out that the exact mirror image version is probably actually better for
	us here than the switched mirror image version above since we probably don't
	have to do any funny stuff to get the $. prefix off the beginning of each bag
	if we don't want it to be there.

	Now suppose you wanted to switch states without sending the present state's
	here: block's x to the next state?  Suppose instead you wanted the x to be stuffed
	into the present state's here: block and then switch states to the next state?
	Like if you were going from state 1 to state 2 because x = $.  Then you could do-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ #( 2 ) ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ #( 1 ) ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	) in which case when we are switching from state 1 to state 2 because x = $. then
	the $. goes into the bag for state 1 and then the bag for state 1 is returned. And then
	on the next ( r next ) call state 2 starts up on the next x in the base sequence.
	Now we have solved the problem of the $. not being on the end of the sentences
	we want to find and return.

	Now you're not supposed to do this but suppose you just wanted to peek
	at x and then switch to some other state to have that state process the x.
	WELL DON'T DO IT!!!!!!						( just kidding )
	Perhaps something like-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ #( peek 2 ) ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ #( peek 1 ) ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	)could do the job.   Except that now you get into an infinite loop as soon as you hit
	the first $. in line.  oooooooh no good.  But if the states were not mirrored it might
	work.  But that is not supposed to be the style of sortInto: finite state machines.
	You are not supposed to want to peek.
	( But on the other hand, perhaps it could be argued that peeking might make
		certain situations more code minimal. )
	No you are NOT supposed to be doing this kind of peeking
	because every state should be able to jump directly to any other state and process
	any other state's junk.  So for this reason you like to use BlockClosures sometimes
	a lot to make multiple state's here: blocks and other blocks be able to do exactly
	the same thing.  So like we might make-:(
		( checkForPeriodBlk := 
			[ :x :i :j | ( x = $. )ifTrue:[ i ]ifFalse:[ j ] ] ).
	)and then do-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | checkForPeriodBlk p:( x )p:( 2 )p:( 1 ) ]
		here:( nil )whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | checkForPeriodBlk p:( x )p:( 1 )p:( 2 ) ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	) where >>p:p:p: = >>with:with:with: .  Which is another pathological example
	that you would never actually do probably but it shows the idea.

	Sometimes you might want a state you are switching to to know what the state you
	just came from was.  In that case you can use Boolean flags-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ lastStateWas:=1. 2 ]ifFalse:[ 1 ] ]
		here:[ :bag :x | lastStateWas=2 ifTrue:[ ... ]ifFalse:[ ... ] ]whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ lastStateWas:=2. 1 ]ifFalse:[ 2 ] ]
		here:[ :bag :x | lastStateWas=1ifTrue:[ ... ]ifFalse:[ ... ] ]whenLeaving:( nil )
		)
	)
	)

	) which is somewhat pathological because we have just two states so we always
	know which state we are coming from but again, give me a break.

	Or perhaps self-:( this method ) could be modified so that you could do-:(

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ #( 2 lastStateWas: 1 ) ]ifFalse:[ 1 ] ]
		here:[ :bag :x :last | last=2ifTrue:[...]ifFalse:[...] ]whenLeaving:( nil ) ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ #( 1 lastStateWas: 2 ) ]ifFalse:[ 2 ] ]
		here:[ :bag :x :last | last=1ifTrue:[...]ifFalse:[...] ]whenLeaving:( nil )
		)
	)
	)

	)in which case sortInto: would have to be able to notice how many parameters
	the here: block was taking which it could do.  If I wanted to worrry.  What me
	worry?

	If KEGFooArray is returned 
	by the whenLeaving: Block during a change of state from the present FSM state
	to a new FSM state( ie: KEGFooArray in place of the customary bag )
	THEN-: nothing is returned by the Generator r in response to the present
	( r next ) message that r is in the middle of and then r continues on to the next
	state.  ( ie: the present >>next message that r is in the middle of doesn't return
	like it would if a bag was returned by the present whenLeaving: block but instead
	goes on to the next FSM state.

	( r :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:[ :bag | KEGFooArray ] ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	). ( See
	KEGRuleBaseParam>>when:here:whenLeaving: ) )

	( self-:( this method ) returns a new KEGGenerator G ( ie: let it be called G ).
	Then-: as of <D:20030212> when the nextState selector here: Block returns nil
	instead of the customary Natural Integer or Array with a Natural Integer in it
	THEN-: the Generator G returned will stop and the ( G next ) message call that
	G is in the middle of then will return nil and all the ( G next ) messages sent to
	G after that will also return nil until G is
	reset via the ( G reset ) message.

	
	( G :=
	( aGen sortInto:( KEGRuleBaseParam new 
	   ''1''when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]
		here:( nil )whenLeaving:[ :bag | KEGFooArray ] ;
		''............................................''
	   ''2''when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ nil ] ]
		here:( nil )whenLeaving:( nil )
		)
	)
	)

	)-<D:20030212>

	( When ignoring the person specific initials KEG
	as if there may be other Generator classes or subClasses made by other
	people besides KEG then I just leave the KEG off.  Because of lazy typing or
	something. )

	<<See Zoomer FILE: c:\teleagnt\text\paperfil.zmr AT:  >>
	or select the following-: << See HelpString AT-: 7 >> and do-:
	RightClick=> Manipulate...=> ===> Get Text Pointed At by Selection .

	KEG5: Replaced KEGFooArray with aFooArray because
	KEGFooArray can legally exist in self as regular parts of the self data sequence.
	So we need something more unique to self-:( this method ) to mark the end of self.
	Also replaced KEGFooArray with aFooArray in the ignore: stuff above for the
	same reason.  Also kept up the functionality where if KEGFooArray is returned 
	by the whenLeaving: Block during a change of state from the present FSM state
	to a new FSM state( ie: KEGFooArray in place of the customary bag )
	THEN-: nothing is returned by the Generator G in response to the present
	>>next message that G is in the middle of and then G continues on to the next
	state.  ( ie: the present >>next message that G is in the middle of doesn't return
	like it would if a bag was returned by the present whenLeaving: block but instead
	goes on to the next FSM state ). ( See
	KEGRuleBaseParam>>when:here:whenLeaving: ) )

	KEG6: ( <D:20010731> ? )
	Changed-:(
		'KEGFooArray new )asGenerator' 
	) to-:(
		'KEGFooArray new )asSingletonGenerator'
	)
	because a FooArray is an Array so sending an empty Array >>asGenerator just
	returns an empty Generator which just returns nothing but nil when you send it
	the >>first and >>next messages so that is why the last returnBag was never
	being returned because ( x == aFooArray ) was never returning true because the
	#, concatenation Generator was always returning nil instead of the
	FooArray.
	It should return the FooArray as it did before KEG5 above. Before KEG5 it
	returned the KEGFooArray Class and sending that >>asGenerator returned a
	singleton Generator with KEGFooArray as its only element.  Now when we use
	asSingletonGenerator we get back to that functionality.  It is strange that this bug
	never was a serious problem.  And fixing it now was an aside in order to fix the
	KEGMiscScripts>>add: which had the problem of cutting off the last todo
	for a long time. But I just lived with it.
	( other KEG changes are listed below in one of the new changes sections now
	being used in this PicoLARC style of method documentation. )
 )-detail
 usage-:(

	Check out the References or SendersOf self-:( this method ) for usage examples
	and especially the following that have more detailed documentations-:(
		KEGAccountKeepTrackerPosition>>asColoredWordsV2:
	)and also try to look for References of self-:( this method ) that have a lot of
	comments in and amongst the sortInto: Finite State Machine states.  Also try to
	look for References that use the >>when:here:whenLeaving: or
	>>when:here:leaving: methods to set up the FSM states.
	The ones that use the >>when:perform: way may be a lot harder to understand
	as they were made in the bad old days before there was
	>>when:here:whenLeaving: which cleaned things up a lot.

 )-usage
 toDebugEvaluate-:(
	KEGGenDebugger editDebugPresent:( 'KEGGenerator>>sortInto:' )
 )-todebug
 todos-:(

	( [_]:[]:WK SMALLTALK-: Dolphin Smalltalk-:
		Encapsulate the guts of self-:( this method ) in a special current
		instance of a special KEGGenerator subClass
		KEGSortInto Class such that speed optimizations
		can be had and so that the guts of this thing can be encapsulated . )

	( [_]:[]:WK SMALLTALK-: Dolphin Smalltalk-:
		In an example to do with
		KEGTextGenerator>>asOrderedCollection
		it says:
		Here we attatch something onto the front of the Collection
		returned by
		sortInto:
		which is supposed to describe the whole Collection.  And it is a
		mess. a bit.  So this may well be why they always tell you not to
		return elementary Objects like Arrays and Dictionaries and
		such but rather to encapsulate those in special Objects that
		can easily be made to carry extra info about the Collection as
		a whole.  Now it is true that sortInto: always wants to return a
		Generator that always returns OrderedCollections, but via a
		Block like the returnBlk and testing for c = #result one can
		wrap the OC in a special Object just before it is returned.  But
		this too is a bit more messy perhaps than one wants.  One could
		refactor sortInto: into >>sortInto: and >>sortInto:on:
		where >>sortInto: just calls >>sortInto:on: with
		OrderedCollection or [ OrderedCollection new ] as the on:
		parameter.  And the on: parameter tells what the returned
		value is going to be.  Yes.  I like that idea.  I will try to note it in
		KEGGenerator>>sortInto: now . )

 )-todos
 changes-:(
	(| KEG8-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg8
	or
	(| KEG9-:( Changes onDate-:( ... ) theOldCode-:( ... ) wasReplacedBy-:( ... ) )-chg )-keg9
	. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .
	(| KEG9-:( Changes onDate-:( <D:20030410> ) madeChanges-:(
		Added the-:(   nextSI isParam   )and-:( ifNotNil:[ :stuffItIntoState | )
		stuff.  To allow next state Integers to be surrounded by Arrays etc.
		)-madechanges )-chg )-keg9

	(| KEG8-:( Changes onDate-:( <D:20030321> ) theOldCode-:( 'stop' )
		wasReplacedBy-:( 'stopNow' ) and-:( 'stopNow == true' ) and stopNow
		was added as a new local variable in order that the present bag of the
		present state might be returned if self runs out of elements.
	)-chg )-keg8

	(| KEG7-:( Changes onDate-:( <D:20030212> ) madeChanges-:( 
		converted self-:( this method ) over to PicoLARC style and added the
		'ifNil:[ stop := true ]ifNotNil:[ :nextSI |' stuff and the '( stop )ifFalse:'
		stuff so that now if the selector Block( monadicValuable ) returns nil
		then self will stop and return nil from then on in response to the
		self>>next message. )-madechanges )-chg )-keg7
 )-changes
 testCases-:( "

	"<---[ PLEASE See the senders of >>sortInto: for more complex examples with more states.  Each of the following has only two states.
		The KEGGeneratorScanReplace-6-0.pac Package in Dolphin has a lot of examples.  It's called the KEGGeneratorScanReplace
		Package in Pharo Smalltalk.
		Each >>when:here:whenLeaving: creates a new state in the finite state machine.  Notice that often times the states are mirror
		images of each other.  This happens a lot.  And often if you get stuck and states seem to proliferate with no end in sight then
		if you think about using mirror images then everything falls into place.
		The >>asSequence message creates a KEGGenerator which then gets modified by >>sortInto: which returns another KEGGenerator
		which the >>collect: message modifies returning a new KEGGenerator which finally gets iterated by >>asArray . ]"

	( self assert:(
	(
	( '' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #(  ) )
	) description:( ' >>sortInto: 1 the empty case' ) ).

	( self assert:(
	(
	( '12345' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( ( $1 $2 $3 $4 $5 ) )
	) description:( ' >>sortInto: 2 showing no state change case' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 ) #( $. $6 $7 $8 $9 ) #( $. $1 $2 $3 $4 ) )
	) description:( ' >>sortInto: 2 showing case you think of first' ) ).

	( self assert:(
	(
	( '12345.6789.1234.' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 ) #( $. $6 $7 $8 $9 ) #( $. $1 $2 $3 $4 ) #( $. ) )
	) description:( ' >>sortInto: 2 showing case you think of second' ) ).

	"<---[ Remember that the :oc above is an OrderedCollection that is global to the >>sortInto: created KEGGenerator so if we don't make copies of it then asArray makes
		a mess. But often you don't need to make copies because each copy is discarded before the next iteration and so memory allocations are reduced if we don't copy.
		Each state has it's own bag which is an OrderedCollection.  The bags are not Bags they are OrderedCollections.  I just like to call them bags. ]"
	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	)
	) asArray asString = 'an Array(an OrderedCollection($. $1 $2 $3 $4) an OrderedCollection() an OrderedCollection($. $1 $2 $3 $4))'
	) description:( ' >>sortInto: 3 showing the OrderedCollection state bags are global to the >>sortInto: created KEGGenerator ' ) ).

	( self assert:(
	(
	( '.12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #(  ) #( $. $1 $2 $3 $4 $5 ) #( $. $6 $7 $8 $9 ) #( $. $1 $2 $3 $4 ) ) 
	) description:( ' >>sortInto: 4 showing empty initial state' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | x ]whenLeaving:[ :bag | bag ] ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:[ :bag :x | x ]whenLeaving:[ :bag | bag ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 ) #( $. $6 $7 $8 $9 ) #( $. $1 $2 $3 $4 ) )
	) description:( ' >>sortInto: 5 showing BlockClosures instead of nil ' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | x ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:[ :bag :x | x ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 1 ) #( $. $6 $7 $8 $9 2 ) #( $. $1 $2 $3 $4 1 ) )
	) description:( ' >>sortInto: 6 showing whenLeaving: state sequencing' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | ( bag add: 1.0 ).( x ) ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1.0 $5 1 ) #( 2.0 $. 2.0 $6 2.0 $7 2.0 $8 2.0 $9 2) #( 1.0 $. 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1) )
	) description:( ' >>sortInto: 7 showing state sequencing ' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | ( bag add: 1.0 ).( x ) ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ nil ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( ( 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1.0 $5 1 ) )"<---[ The bag for state 2 is not returned because of the nil ]"
	) description:( ' >>sortInto: 7 showing state sequencing and returning nil to terminate the KEGGenerator' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | ( bag add: 1.0 ).( x ) ]whenLeaving:[ :bag | #( 1 ) ] ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( ( 1 ) ( 2.0 $. 2.0 $6 2.0 $7 2.0 $8 2.0 $9 2 ) ( 1 ) )"<---[ We are returning #( 1 ) for state 1 instead of its bag ]"
	) description:( ' >>sortInto: 7 showing state sequencing and returning #( 1 ) instead of a state bag' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | ( bag add: 1.0 ).( x ) ]whenLeaving:[ :bag | KEGFooArray ] ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( ( 2.0 $. 2.0 $6 2.0 $7 2.0 $8 2.0 $9 2 ) )"<---[ The KEGFooArray says don't return anything for this state ]"
	) description:( ' >>sortInto: 7 showing state sequencing and returning #( 1 ) instead of a state bag' ) ).

	( self assert:(
	(
	( '.12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:[ :bag :x | ( bag add: 1.0 ).( x ) ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( 1 ) #( 2.0 $. 2.0 $1 2.0 $2 2.0 $3 2.0 $4 2.0 $5 2 ) #( 1.0 $. 1.0 $6 1.0 $7 1.0 $8 1.0 $9 1 ) #( 2.0 $. 2.0 $1 2.0 $2 2.0 $3 2.0 $4 2 ) )
	) description:( ' >>sortInto: 8 empty initial state and showing state sequencing' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ #( 2 ) ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ #( 1 ) ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil )
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( $1 $2 $3 $4 $5 $. ) #( $6 $7 $8 $9 $. ) #( $1 $2 $3 $4 ) )
	) description:( ' >>sortInto: 9 wrapping each different next state in an Array to [ append to end ] of each state' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ #( 2 ) ]ifFalse:[ 1 ] ]here:[ :bag :x | ( bag add: 1.0 ).( x ) ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ #( 1 ) ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1.0 $5 1.0 $. 1 ) #( 2.0 $6 2.0 $7 2.0 $8 2.0 $9 2.0 $. 2 ) #( 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1 ) )
	) description:( ' >>sortInto: 10 wrapping each different next state in an Array and showing state sequencing ' ) ).

	( self assert:(
	(
	( '12345.6789.1234.' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ #( 2 ) ]ifFalse:[ 1 ] ]here:[ :bag :x | ( bag add: 1.0 ).( x ) ]whenLeaving:[ :bag | bag add: 1 ; yourself ] ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ #( 1 ) ]ifFalse:[ 2 ] ]here:[ :bag :x | ( bag add: 2.0 ).( x ) ]whenLeaving:[ :bag | bag add: 2 ; yourself ]
		)
	) collect:[ :oc | oc asArray ]
	) asArray = #( #( 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1.0 $5 1.0 $. 1 ) #( 2.0 $6 2.0 $7 2.0 $8 2.0 $9 2.0 $. 2 ) #( 1.0 $1 1.0 $2 1.0 $3 1.0 $4 1.0 $. 1 ) #( 2 ) )
	) description:( ' >>sortInto: 11 showing empty last state and wrapping each different next state in an Array and showing state sequencing ' ) ).

 " )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGGeneratorTest methodsFor: '*KEGGeneratorFiniteStateMachinesTest' stamp: 'KjellGodo 5/18/2013 11:57'!
testsortIntoChangeOCsToGenerators "sortIntoChangeOCsToGenerators"

	"Method Version: keg1.  "
	" Copyright Kjell E God Jun 11 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Jun 11 2000"
	"<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>""
	| answer gen |
						""MT b:#sortIntoChangeOCsToGenerators s:self.""

	gen := KEGGenerator streamGenerator .
	answer := self collect:[ :oc | oc asStreamGeneratorOn: gen ] .

						""MT e:#sortIntoChangeOCsToGenerators s:self.""
	^answer .

	""This method can be used after the self>>sortInto: method to convert the reused
	OrderedCollection OC returned by the Generator G returned by the self>>sortInto: method
	into Generators OCG in a somewhat efficient way by reusing the returned Generator OCG.
	self>>sortInto: returns G.  G returns OC.  ( G sortIntoChangeOCsToGenerators ) returns
	a Generator GG.  GG returns OCG over and over again with different contents each time."

	| reuseableGen |

	( self assert:(
	(
	( '' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToGenerators collect:[ :gen | gen asArray ]
	) asArray = #( #(  ) )
	) description:( ' >>sortIntoChangeOCsToGenerators 1 the empty case' ) ).

	( self assert:(
	(
	( '' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToGenerators
	) asArray asString = 'an Array(a KEGGenerator)'
	) description:( ' >>sortIntoChangeOCsToGenerators 1 the empty case no copying and show the generator' ) ).

	( self assert:(
	(
	( '12345' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToGenerators collect:[ :gen | ( gen first: 3 ) asArray ]
	) asArray = #( ( $1 $2 $3 ) )
	) description:( ' >>sortIntoChangeOCsToGenerators 2 showing no state change case' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToGenerators collect:[ :gen | ( gen first: 3 ) asArray ]
	) asArray = #( #( $1 $2 $3 ) #( $. $6 $7 ) #( $. $1 $2 ) )
	) description:( ' >>sortIntoChangeOCsToGenerators 2 showing case you think of first' ) ).

	( reuseableGen := KEGGenerator streamGenerator first: 3 ).
	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToGenerators collect:[ :gen | ( reuseableGen onGenerator: gen ; yourself ) asArray ]"<---[ We don't reAllocate the first: Generator each time through the loop ]"
	) asArray = #( #( $1 $2 $3 ) #( $. $6 $7 ) #( $. $1 $2 ) )
	) description:( ' >>sortIntoChangeOCsToGenerators 2 showing case you think of first with reuseable Generator' ) ).

	( reuseableGen := #(  ) asGen first: 3 ).
	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToGenerators collect:[ :gen | ( reuseableGen onGenerator: gen ; yourself ) asArray ]"<---[ We don't reAllocate the first: Generator each time through the loop ]"
	) asArray = #( #( $1 $2 $3 ) #( $. $6 $7 ) #( $. $1 $2 ) )
	) description:( ' >>sortIntoChangeOCsToGenerators 2 showing case you think of first with reuseable Generator' ) ).
! !

!KEGGeneratorTest methodsFor: '*KEGGeneratorFiniteStateMachinesTest' stamp: 'KjellGodo 5/18/2013 12:05'!
testsortIntoChangeOCsToStringGenerators "sortIntoChangeOCsToStringGenerators"

	"Method Version: keg1.  "
	" Copyright Kjell E God Jun 11 2000"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Jun 11 2000"
	"<< OWNER-: Kjell E God SOFTWARE-: picoVerse VERSION-: 1 >>""
	| answer gen stGen |
						""MT b:#sortIntoChangeOCsToStringGenerators s:self.""

	stGen := ( gen := KEGGenerator streamGenerator ) asStringGenerator .
	answer := self collect:[ :oc | oc asStreamGeneratorOn: gen . stGen ] .

						""MT e:#sortIntoChangeOCsToStringGenerators s:self.""
	^answer .
	""This method can be used after the self>>sortInto: method to convert the reused
	OrderedCollection OC returned by the Generator G returned by the self>>sortInto: method
	into StringGenerators OCSG in a somewhat efficient way by reusing the returned Generator OCSG.
	self>>sortInto: returns G.  G returns OC over and over again with different contents.
	( G sortIntoChangeOCsToStringGenerators ) returns a Generator GSG.  GSG returns
	OCSG over and over again with different contents each time.  To get a KEGGenerator
	to return things first you send it the >>reset message and then the >>next message over
	and over.  Usually an iteration message like KEGGenerator>>do: is used to do this."

	| reuseableGen |

	( ( Smalltalk at: #KEGStringGenerator ifAbsent:[  ] ) notNil ifTrue:[

	( self assert:(
	(
	( '' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToStringGenerators collect:[ :gen | gen asArray ]
	) asArray = #( #(  ) )
	) description:( ' >>sortIntoChangeOCsToStringGenerators 1 the empty case' ) ).

	( self assert:(
	(
	( '' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToStringGenerators
	) asArray asString = '#(a KEGStringGenerator)'
	) description:( ' >>sortIntoChangeOCsToStringGenerators 1 the empty case' ) ).

	( self assert:(
	(
	( '12345' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToStringGenerators collect:[ :gen | ( gen first: 3 ) asArray ]
	) asArray = #( ( $1 $2 $3 ) ) "<---[ KEGStringGenerators leave Characters alone ]"
	) description:( ' >>sortIntoChangeOCsToStringGenerators 2 showing no state change case' ) ).

	( self assert:(
	(
	( #( 1 2 3 4 5 ) asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToStringGenerators collect:[ :gen | ( gen first: 3 ) asArray ]
	) asArray = #( ( '1' '2' '3' ) ) "<---[ KEGStringGenerators turn everything into Strings ]"
	) description:( ' >>sortIntoChangeOCsToStringGenerators 2 showing no state change case and String conversions ' ) ).

	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToStringGenerators collect:[ :gen | ( gen first: 3 ) asArray ]
	) asArray = #( #( $1 $2 $3 ) #( $. $6 $7 ) #( $. $1 $2 ) )
	) description:( ' >>sortIntoChangeOCsToStringGenerators 2 showing case you think of first' ) ).

	( reuseableGen := KEGGenerator streamGenerator first: 3 ).
	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToStringGenerators collect:[ :gen | ( reuseableGen onGenerator: gen ; yourself ) asArray ]"<---[ >>first: 3 Generator allocated only once ]"
	) asArray = #( #( $1 $2 $3 ) #( $. $6 $7 ) #( $. $1 $2 ) )
	) description:( ' >>sortIntoChangeOCsToStringGenerators 2 showing case you think of first' ) ).

	( reuseableGen := #(  ) asGenerator first: 3 ).
	( self assert:(
	(
	( '12345.6789.1234' asSequence sortInto:( KEGRuleBaseParam new 
	   "1"when:[ :x | ( x = $. )ifTrue:[ 2 ]ifFalse:[ 1 ] ]here:( nil )whenLeaving:( nil ) ;
	   "2"when:[ :x | ( x = $. )ifTrue:[ 1 ]ifFalse:[ 2 ] ]here:( nil )whenLeaving:( nil ) "<---[ nil = [ :x | x ] and nil = [ :b :x | x ] because of nil>>value: and nil>>value:value: ]"
		)
	) sortIntoChangeOCsToStringGenerators collect:[ :gen | ( reuseableGen onGenerator: gen ; yourself ) asArray ]"<---[ >>first: 3 Generator allocated only once ]"
	) asArray = #( #( $1 $2 $3 ) #( $. $6 $7 ) #( $. $1 $2 ) )
	) description:( ' >>sortIntoChangeOCsToStringGenerators 2 showing case you think of first' ) )

	] )."<---[ ifTrue: ]"! !
